/* Inizializza una nuova partita */
bool init()
{
  cout << "[I] Init() the game...";
  player.punti = 0;
  player.vite = 2;
  lvl = startLvl;
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  if (! filelvl.is_open()) filelvl.open("livelli.lvl", ios::in | ios::out | ios::binary);
  cout << "[DONE]\n";
  return true;
}

/* Inizializza un nuovo set */
bool begin()
{
  player.x = 320;
  player.lung = 40; /* Metà paddle */
  if (! palla.init()) return false;
  msg("Premi Spazio per iniziare");
  return true;
}

bool grafica()
{
  boxColor(schermo, 0, 0, 639, 479, 0x000000FF); /* Cancella tutto */
  Uint32 colore;
  for (short y = 0; y < height; y++)
    for (short x = 0; x < width; x++)
    {
      /* per maggiori informazioni vedere anche leggimi.txt */
      switch (block[x][y])
      {
        case  0: case 9: colore = 0x000000FF; break;  /* vuoto */
        case 10: colore = 0x008200FF; break;  /* pezzo normale */
        case 11: colore = 0xB40000FF; break;  /* pezzo doppio  */
        case 12: colore = 0x0000B4FF; break;  /* pezzo triplo  */
        case 13: colore = 0xFDD017FF; break;  /* pezzo Gold    */
        case 128: colore = 0x800080FF; break;  /* rallenta      */
        case 129: colore = 0xFF00FFFF; break;  /* accelera      */
        case 130: colore = 0xFFA500FF; break;  /* allarga       */
        case 131: colore = 0xFFFF00FF; break;  /* restringi     */
        case 140: colore = 0xFFFFFFFF; break;  /* extra life    */
        case 150: colore = 0x00000000; break;  /* The Boss      */
        case 151: colore = 0x404040FF; break;  /* Invincible    */
        case 152: colore = 0x606060FF; break;
        case 153: colore = 0x505050FF; break;
        case 154: colore = 0x404040FF; break;
        default: colore = 0x400000CC; scrivi("Bad block found!\n"); clog << "[W] Bad block found!\n"; break;
      }
      boxColor(schermo, x * largBlock, y * altBlock, x * largBlock + largBlock - 2, y * altBlock + altBlock - 2, colore);
    }

  boxColor(schermo, player.x - player.lung, 460, player.x + player.lung, 470, 0xC8C8C8FF);
  palla.grafica();
  stringColor(schermo, 10, 10, "Vite:", 0xFFFFFFFF);
  stringColor(schermo, 58, 10, itoa(player.vite, 10), 0xFFFFFFFF);
  stringColor(schermo, 140, 10, "Punti:", 0xFFFFFFFF);
  stringColor(schermo, 196, 10, itoa(player.punti, 10), 0xFFFFFFFF);
  stringColor(schermo, 300, 10, itoa(lvl, 10), 0xFFFFFFFF);
  stringColor(schermo, 320, 10, title, 0xC80000FF);
  SDL_Flip(schermo);
  return true;
}

/* Ritorna true solo se è passato almeno il tempo di un fotogramma, così, se
 * l'esecuzione è stata molto veloce, evita di ridisegnare inutilmente lo schermo */
bool fps()
{
  /* periodo = 1/maxfps (indicare in millisecondi) */
  double periodo = 33;
  unsigned int ritardo = SDL_GetTicks() - lastframe - 1;
  if (ritardo < periodo) { SDL_Delay(1); return false; }
  lastframe = SDL_GetTicks();
  return true;
}

bool gioca() {
  if (! init()) { cerr << "[E] Fatal error: unable to init() the game!\n"; return false; }
  if (! begin()) { cerr << "[E] Fatal error: unable to begin() the game!\n"; return false; }
  if (! livello()) return false;

  while (true)
  {
    SDL_PumpEvents();
    if (tasto[SDLK_RIGHT]) player.x = player.x + 0.4;
    if (tasto[SDLK_LEFT]) player.x = player.x - 0.4;
    if (tasto[SDLK_ESCAPE]) { gameover(); return true; }
    if (tasto[SDLK_a])
    {
      scrivi("\a"); scrivi("Abbandono del livello");
      player.vite--;
      if (player.vite < 0) { gameover(); return true; }
        else { begin(); livello(); }
    }
    if (tasto[SDLK_p]) { msg(" -- Pausa -- ");}

    /* Evita che il paddle esca dallo schermo */
    if (player.x <= 0) player.x = 0;
    if (player.x >= 639) player.x = 639;
    switch (palla.muovi())
    {
      case 'l': /* Palla persa */
        player.vite--;
        if (player.vite < 0) { gameover(); record(); return true; }
          else begin();
        break;
      case 'c': /* Livello completato */
        begin(); livello();
        break;
      case 'o': case 'h': /* Ok */ break;
      default: cout << "[W] Unespected return value from muovi() in class 'proietto'" << endl; break;
    }

    if (fps()) grafica();
  }

  return true;
}

