#include <iostream>
using namespace std;
#include <fstream>
#include <SDL/SDL.h>
#include <SDL/SDL_gfxPrimitives.h>

char versione[15];
SDL_Surface* schermo = NULL;
Uint8 *tasto = SDL_GetKeyState(NULL);
double lastframe = time(NULL);
/* Numero di blocchi nello schermo, in larghezza e altezza */
const unsigned short width = 16;
const unsigned short height = 24;
/* Dimensioni fisiche dei blocchi, in pixel */
const unsigned short largBlock = 640 / width;
const unsigned short altBlock = 480 / height;
unsigned char block[width][height];
#include "tipi.cpp"
giocatore player;
#include "info.cpp"
#include "classi.cpp"
proietto palla;
/* Livello corrente e livello iniziale, rispettivamente */
int lvl, startLvl = 0;
/* File con gli schemi per i livelli - vedere livelli.cpp per la descrizione */
fstream filelvl;
char title[64];

#include "menu.cpp"
#include "livelli.cpp"
#include "gameover.cpp"
#include "gioca.cpp"

int main(int argc, char *argv[])
{
  /* NUMERO DI VERSIONE DEL PROGRAMMA */
  strcpy(versione, "0.99beta");
  Uint32 SCHERMOINTERO = 0;
  Uint32 DOPPIO = SDL_DOUBLEBUF;
  /* Lettura dei parametri da riga di comando */
  for (short v = 0; v < argc; v++)
  {
    if (argv[v][0] == '-')
    {
      switch (argv[v][1])
      {
        case 'l': startLvl = atoi(argv[v + 1]) - 1; break;
        case 'h': infocmd(); return 0; break;
        case 'f': SCHERMOINTERO = SDL_FULLSCREEN; /* DOPPIO = 0 */; break;
        case 'v': cout << "P Pong version " << versione << endl; break;
        default: clog << "[W] Parametro sconosciuto!\n"; break;
      }
    }
  }
  infolog();
  SDL_Init(SDL_INIT_VIDEO);
  schermo = SDL_SetVideoMode(640, 480, 32, SDL_SWSURFACE | DOPPIO | SCHERMOINTERO);
  if (schermo == NULL)
  { cerr << "[E] Fatal error: Unable to SetVideoMode(). Run in a graphic environment!\n"; return 1; }

  while (true)
  {
    SDL_WM_SetCaption("P Pong by gbr", 0);
    menuShow();
    switch (menuEntry())
    {
      case 'q': cout << "[I] Have a nice day...\n"; SDL_Quit(); return 0;
      case 'i': info(); break;
      case 'g': if (! gioca()) msg("FATAL ERROR! Check log on console for more details."); break;
      default: break;
    }
  }

  SDL_Quit();
  return 0;
}

/*
 * P Pong
 * Programmato da Giovan Battista Rolandi
 * http://gbr.altervista.org
 * Luglio - Agosto 2012
*/
